<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                xmlns:fn="http://www.w3.org/2005/xpath-functions"
                version="2.0">

    <xsl:output method="xml"
                indent="yes"
                encoding="UTF-8" />

    <xsl:template match="element()">
        <xsl:variable name="xelement" select="." />
        <xsl:variable name="str" select="fn:normalize-space($xelement)" />
        <xsl:if test="fn:string-length($str) ne 0">
            <xsl:variable name="qname" select="$xelement/fn:name()" />
            <xsl:variable name="ns" select="fn:namespace-uri($xelement)" />
            <!-- <xsl:message>Creating node:  <xsl:value-of select="$qname" /></xsl:message> -->
                <xsl:element name="{$qname}" namespace="{$ns}">
                    <!-- There are no attributes in this taxonomy -->
                    <xsl:copy-of select="@*"/> 
                    <xsl:apply-templates select="element()" />
                    <xsl:if test="fn:not(./element())">
                        <xsl:variable name="data" select="fn:normalize-space(.)" />
                        <xsl:if test="fn:string-length($data) ne 0">
                            <xsl:value-of select="./text()[1]" />
                        </xsl:if>
                    </xsl:if>
                </xsl:element>
        </xsl:if>
    </xsl:template>

    <xsl:template match="text() | @*" />

</xsl:stylesheet>